package com.sample.jbpm;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.ejb.Stateless;
import javax.inject.Inject;

import org.drools.runtime.StatefulKnowledgeSession;
import org.drools.runtime.process.ProcessInstance;

@Stateless
public class TradeHandlerImpl {

	@PersistenceContext(unitName="org.jbpm.persistence.jpa")
	private EntityManager em;

	public long start() {
			KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
			kbuilder.add(ResourceFactory.newClassPathResource("MainProcess.bpmn"), ResourceType.BPMN2);
			kbuilder.add(ResourceFactory.newClassPathResource("SubProcess.bpmn"), ResourceType.BPMN2);
			kbuilder.add(ResourceFactory.newClassPathResource("SubProcess2.bpmn"), ResourceType.BPMN2);
			KnowledgeBase kbase = kbuilder.newKnowledgeBase();
				
			Environment env = KnowledgeBaseFactory.newEnvironment();
		
			env.set(EnvironmentName.ENTITY_MANAGER_FACTORY, em.getEntityManagerFactory());
			PersistenceContextManager pcm = new JpaPersistenceContextManager(env);
			env.set(EnvironmentName.PERSISTENCE_CONTEXT_MANAGER, pcm);
			
			StatefulKnowledgeSession ksession = null;

			ksession = JPAKnowledgeService.newStatefulKnowledgeSession(
					kbase.getKBase(),
					null,
					env);

			Map<String, Object> params = new HashMap<String, Object>();
			
			List<String> clients = new ArrayList<String>();
			
			clients.add("A");
			clients.add("B");
			
			params.put("clients", clients);
			ProcessInstance pi = ksession.startProcess("com.sample.bpmn.main", params);
			return pi.getId();
	}

}
